import { defineComponent as c } from "../../../../node_modules/@vue/composition-api/dist/vue-composition-api.js";
import e from "dayjs";
import "../../../assets/scss/dinert-time-player.scss.js";
const h = (t, i, s) => {
  const r = e(i).valueOf() - e(t).valueOf();
  let a = e(i).valueOf() - e(s).valueOf();
  return a = r - a, a / r * 100;
}, p = (t, i, s) => {
  const r = t.currentTarget, a = t.layerX + 1, l = r.offsetWidth;
  let o = a / l;
  const n = e(s).valueOf() - e(i).valueOf(), m = e(i).valueOf() + e(n * o).valueOf();
  return o = o * 100, {
    timestamp: e(m).startOf("hours").valueOf(),
    time: e(m).startOf("hours").format("YYYY-MM-DD HH:mm:ss"),
    percent: o,
    width: a
  };
}, v = c({
  name: "dinert-time-player",
  props: {
    modelValue: {
      type: Date,
      default: () => new Date(e().subtract(1, "day").startOf("hour").valueOf())
    },
    startTime: {
      // 开始时间
      type: Date,
      default: () => new Date(e().subtract(2, "day").startOf("day").valueOf())
    },
    endTime: {
      // 结束时间
      type: Date,
      default: () => new Date(e().add(2, "day").startOf("day").valueOf())
    },
    currentTime: {
      // 时间轴当前时间
      type: Date,
      default: () => new Date(e().subtract(1, "day").startOf("hour").valueOf())
    },
    // 时间轴停止的时间
    stopTime: {
      type: Date,
      default: () => new Date(e().add(2, "day").startOf("day").valueOf())
    },
    // 底部时间格式化
    formatFooter: {
      type: String,
      default: "YYYY年MM月DD日"
    },
    // tooltip时间格式化
    formatTooltip: {
      type: String,
      default: "YYYY年MM月DD日 HH时"
    },
    // 24小时时间的间隔
    interval: {
      type: Number,
      default: 3
    },
    delay: {
      // 播放时间间隔
      type: Number,
      default: 2e3
    }
  },
  data() {
    return {
      barRef: null,
      tooltipRef: null,
      tempTooltipRef: null,
      isTempTooltip: !1,
      isPlay: !1,
      config: {},
      timeTimeout: null,
      currentTempTime: this.currentTime,
      hoverTime: this.currentTime,
      timeClickFlag: !1
    };
  },
  mounted() {
    this.barRef = this.$refs.barRef, this.tooltipRef = this.$refs.tooltipRef, this.tempTooltipRef = this.$refs.tempTooltipRef, this.animateAfter();
    const t = h(this.startTime, this.endTime, this.currentTempTime);
    this.autoMove(t, void 0);
  },
  computed: {
    items() {
      const t = [];
      let r = e(this.startTime).valueOf();
      const a = e(this.endTime).diff(e(this.startTime), "days"), l = 100 / a + "%", o = 100 / (24 / this.interval);
      for (let n = 0; n < a; n++) {
        const m = [];
        let f = 0;
        for (let u = 1; u < 24; u++)
          u % this.interval === 0 && (f++, m.push({
            text: u,
            left: o * f + "%",
            id: Math.random()
          }));
        t.push({
          hours: m,
          time: e(r).format(this.formatFooter),
          width: l
        }), r += 864e5;
      }
      return t;
    },
    formatTooltipText() {
      return e(this.currentTempTime).format(this.formatTooltip);
    },
    formatTempTooltipText() {
      return e(this.hoverTime).format(this.formatTooltip);
    }
  },
  methods: {
    autoMove(t, i) {
      var r;
      !i && this.isPlay && (this.currentTempTime = e(this.currentTempTime).add(1, "hours").toDate());
      let s = t || h(this.startTime, this.endTime, this.currentTempTime);
      s > 100 && (s = 100), this.barRef && (this.barRef.style.width = s + "%"), this.tooltipRef && (this.tooltipRef.style.left = s + "%"), i || (this.config = {
        percent: s,
        time: e(this.currentTempTime).startOf("hours").format("YYYY-MM-DD HH:mm:ss"),
        width: (r = this.barRef) == null ? void 0 : r.offsetWidth,
        timestamp: e(this.currentTempTime).startOf("hours").valueOf()
      }), e(this.stopTime).startOf("hours").valueOf() <= e(this.currentTempTime).valueOf() && (this.isPlay = !1), this.isPlay ? (this.timeTimeout && clearTimeout(this.timeTimeout), this.timeTimeout = setTimeout(() => {
        this.autoMove(void 0, void 0);
      }, this.delay)) : this.timeTimeout && clearTimeout(this.timeTimeout);
    },
    timeClick(t) {
      this.timeClickFlag = !0, this.config = p(t, this.startTime, this.endTime), !(e(this.stopTime).startOf("hours").valueOf() <= e(this.config.time).valueOf()) && (this.currentTempTime = e(this.config.time).toDate(), this.autoMove(this.config.percent, t), this.$emit("animate-before", this.config));
    },
    animateAfter() {
      this.barRef && this.barRef.addEventListener("transitionend", () => {
        this.timeClickFlag ? this.timeClickFlag = !1 : this.$emit("animate-after", this.config);
      });
    },
    timeMouseEnter(t) {
      const i = p(t, this.startTime, this.endTime);
      this.tempTooltipRef && (this.tempTooltipRef.style.left = i.percent + "%"), this.hoverTime = e(i.time).toDate(), this.isTempTooltip = !0;
    },
    timeMouseLeave() {
      this.isTempTooltip = !1;
    },
    timePlay() {
      e(this.stopTime).startOf("hours").valueOf() <= e(this.currentTempTime).valueOf() || (this.isPlay = !this.isPlay, this.isPlay ? (this.timeTimeout && clearTimeout(this.timeTimeout), this.timeTimeout = setTimeout(this.autoMove, this.delay)) : clearTimeout(this.timeTimeout));
    },
    // 开始播放
    startPlay() {
      this.isPlay = !0, this.timeTimeout && clearTimeout(this.timeTimeout), this.timeTimeout = setTimeout(this.autoMove, this.delay);
    },
    stopPlay() {
      this.isPlay = !1, this.timeTimeout && clearTimeout(this.timeTimeout);
    },
    timeNowFn() {
      this.currentTempTime = e(this.currentTime).toDate(), this.autoMove(void 0, void 0);
    }
  },
  render() {
    const t = arguments[0];
    return t("div", {
      class: "dinert-time-player"
    }, [t("div", {
      class: "dinert-time-player-left"
    }, [t("div", {
      class: "dinert-time-player-left-top"
    }), t("div", {
      class: "dinert-time-player-left-bottom",
      on: {
        click: this.timePlay
      }
    }, [t("span", {
      class: ["dinert-time-player-left-bottom-start", this.isPlay ? "stop" : ""]
    })])]), t("div", {
      class: "dinert-time-player-center"
    }, [t("div", {
      class: "dinert-time-player-center-top"
    }, [t("div", {
      class: "dinert-time-player-center-top-bar",
      ref: "barRef"
    }), t("div", {
      class: "dinert-time-player-center-top-tooltip",
      ref: "tooltipRef"
    }, [this.formatTooltipText]), t("div", {
      class: "dinert-time-player-center-top-tooltipTemp",
      ref: "tempTooltipRef",
      directives: [{
        name: "show",
        value: this.isTempTooltip
      }]
    }, [this.formatTempTooltipText]), t("ul", {
      class: "dinert-time-player-center-top-ul",
      on: {
        click: this.timeClick,
        mousemove: (i) => this.timeMouseEnter(i),
        mouseleave: this.timeMouseLeave
      }
    }, [this.items.map((i) => t("li", {
      style: {
        width: i.width
      },
      attrs: {
        time: i.time
      },
      key: i.time
    }))])]), t("div", {
      class: "dinert-time-player-center-center"
    }, [t("ul", {
      class: "dinert-time-player-center-center-ul"
    }, [this.items.map((i) => t("li", {
      class: "dinert-time-player-center-center-ul-li",
      style: {
        width: i.width
      },
      attrs: {
        time: i.time
      },
      key: i.time
    }, [i.hours.map((s) => t("span", {
      key: s.id,
      style: {
        left: s.left
      }
    }, [s.text]))]))])]), t("div", {
      class: "dinert-time-player-center-bottom"
    }, [t("ul", {
      class: "dinert-time-player-center-bottom-ul"
    }, [this.items.map((i) => t("li", {
      class: "dinert-time-player-center-bottom-ul-li",
      style: {
        width: i.width
      },
      attrs: {
        time: i.time
      },
      key: i.time
    }, [i.time]))])])]), t("div", {
      class: "dinert-time-player-right"
    }, [t("span", {
      class: "dinert-time-player-right-now",
      on: {
        click: this.timeNowFn
      }
    }, ["回到当前"])])]);
  }
});
export {
  v as default
};
//# sourceMappingURL=index.js.map
